/**************************************************/
/* baroreflex according to Bertinieri OK-Callback */
/**************************************************/

#include <Xm/Xm.h>
#include "global.h"


void baro_ok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  GC            gc;
  Display       *dpy=XtDisplay(drawing_a);
  Window        xwin=XtWindow(drawing_a);
  Dimension     wd, ht;
  Widget        toplevel;
  baro_struct   *baro;
  int           bpch, asch;
  float         thres, ccsoll;
  float         bp, rr, bp_alt, rr_alt;
  float         brr[4][10000];
  float         *brrx, *brry, cc, prob, z;
  float         as, as_alt;
  unsigned long n, m, na, ne;
  unsigned long ndia, nsys, ndia_alt, nsys_alt;
  unsigned long upcount, downcount, brrptr, seqptr, seqcount, nampli;
  int           updown, i, seqs;
  int           x1, x2, xpos, yunits, yoff, yd;
  
  extern void find_dia(float *data, unsigned long n1, unsigned long n2, float schwelle,
		       unsigned long *dia, unsigned long *sys);
  extern void pearsn(float *x, float *y, unsigned long n, float *r, float *prob, float *z);
  extern void set_color(Widget widget, String fgcolor, String bgcolor, GC gc);
  extern void showmess(Widget widget, char *title, char *text);
  extern void barowin(char *title,
		      unsigned long nampli, unsigned long seqcount,
		      float brr[4][10000]);

  /* Initialization */
  gc=XCreateGC(XtDisplay(drawing_a), RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);
  XtVaGetValues(drawing_a, XmNwidth, &wd, XmNheight, &ht, NULL);
  x1=LMAR+(int)((r.ts_1-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
  x2=LMAR+(int)((r.ts_2-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));

  baro=(baro_struct *) client_data;
  brrx=new float[1000];
  brry=new float[1000];

  bpch=baro->bp_ch;
  thres=baro->thre;
  ccsoll=baro->reg;
  xpos=0; asch=-1;
  for (i=0; i<r.n; i++) {
    if (r.view[i].is_visible) xpos++;
    if (xpos==baro->ch) asch=i;
  }

  /* Zuerst HR-REFLEX */
  if (bpch>=0 && bpch<r.n) {
    na=(unsigned long)(r.ts_1*r.ch[bpch].sr);
    if (na>=r.ch[bpch].n) na=r.ch[bpch].n-1;
    ne=(unsigned long)(r.ts_2*r.ch[bpch].sr);
    if (ne>=r.ch[bpch].n) ne=r.ch[bpch].n-1;
    upcount=0; downcount=0; updown=0; brrptr=0; seqptr=0; seqcount=0; nampli=0;
    n=na; 
    find_dia(r.ch[bpch].data, n, ne, thres, &ndia, &nsys); nampli++;
    ndia_alt=ndia; nsys_alt=nsys;
    n=nsys;
    find_dia(r.ch[bpch].data, n, ne, thres, &ndia, &nsys); nampli++;
    bp_alt=0; 
    for(m=ndia_alt; m<ndia; m++) bp_alt+=r.ch[bpch].data[m];
    bp_alt=bp_alt/(ndia-ndia_alt);
    rr_alt=1000*(ndia-ndia_alt)/r.ch[bpch].sr;
    ndia_alt=ndia; nsys_alt=nsys;
    n=nsys;
    while (n<ne) {
      find_dia(r.ch[bpch].data, n, ne, thres, &ndia, &nsys); nampli++;
      if(ndia<ne){
	bp=0;
	for(m=ndia_alt; m<ndia; m++) bp+=r.ch[bpch].data[m];
	bp=bp/(ndia-ndia_alt);
	rr=1000*(ndia-ndia_alt)/r.ch[bpch].sr;
	if (bp_alt<bp && rr_alt<rr) {
	  updown=1;
	  upcount++;
	  if(upcount==1) {
	    brr[1][brrptr]=bp_alt;
	    brr[2][brrptr]=rr_alt;
	    brr[3][seqptr]=ndia_alt/r.ch[bpch].sr;
	  }
	  if(upcount==2) {
	    brr[1][brrptr+1]=bp_alt;
	    brr[2][brrptr+1]=rr_alt;
	    brr[1][brrptr+2]=bp;
	    brr[2][brrptr+2]=rr;
	  }
	  if(upcount==3) {
	    brr[0][seqptr]=upcount+1; seqptr++; seqcount++;
	    brr[1][brrptr+3]=bp;
	    brr[2][brrptr+3]=rr;
	    brrptr+=4;
	  }
	  if(upcount>3) {
	    brr[0][seqptr-1]=upcount+1;
	    brr[1][brrptr]=bp;
	    brr[2][brrptr]=rr;
	    brrptr++;
	  }
	  downcount=0;
	}
	else if (bp_alt>bp && rr_alt>rr) {
	  updown=-1;
	  downcount++;
	  if(downcount==1) {
	    brr[1][brrptr]=bp_alt;
	    brr[2][brrptr]=rr_alt;
	    brr[3][seqptr]=ndia_alt/r.ch[bpch].sr;
	  }
	  if(downcount==2) {
	    brr[1][brrptr+1]=bp_alt;
	    brr[2][brrptr+1]=rr_alt;
	    brr[1][brrptr+2]=bp;
	    brr[2][brrptr+2]=rr;
	  }
	  if(downcount==3) {
	    brr[0][seqptr]=downcount+1; seqptr++; seqcount++;
	    brr[1][brrptr+3]=bp;
	    brr[2][brrptr+3]=rr;
	    brrptr+=4;
	  }
	  if(downcount>3) {
	    brr[0][seqptr-1]=downcount+1;
	    brr[1][brrptr]=bp;
	    brr[2][brrptr]=rr;
	    brrptr++;
	  }
	  upcount=0;
	}
	else {
	  updown=0;
	  downcount=0;
	  upcount=0;
	}
	bp_alt=bp; rr_alt=rr;
      }
      ndia_alt=ndia; nsys_alt=nsys;
      n=nsys;
    }

    /* draw vertical lines at rectangle */
    yunits=0;
    for (i=0; i<r.n; i++)
      if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
    yoff=0;
    for (i=0; i<=bpch; i++) {
      if (r.view[i].is_visible) {
	yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	yoff+=yd;
      }
    }
    set_color(drawing_a, "blue", NULL, gc);
    XDrawLine(dpy, xwin, gc, x1, yoff, x1, yoff-yd);
    XDrawLine(dpy, xwin, gc, x2, yoff, x2, yoff-yd);
    set_color(drawing_a, "black", NULL, gc);
    m=0; seqs=0; 
    for (n=0; n<seqcount; n++) {
      for(i=0; i<brr[0][n]; i++) {
	brrx[i]=brr[1][m];
	brry[i]=brr[2][m];
	m++;
      }
      pearsn(brrx-1,brry-1,(unsigned long) brr[0][n], &cc, &prob, &z);
      if (fabs(cc)>=ccsoll) {
	xpos=LMAR+(int)((brr[3][n]-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	set_color(drawing_a, "red", NULL, gc);
	XDrawLine(dpy,xwin,gc,
		  xpos, yoff,
		  xpos, yoff-yd);
	set_color(drawing_a, "black", NULL, gc);
	seqs++;
      }
      else {
	brr[0][n]=(-1)*brr[0][n];
      }
    }
    /* show report */
    barowin("Baroreflex Analysis: Heart Rate", nampli, seqcount, brr);
  }  // end of hr-reflex;

  /* Dann ASSOCIATED-REFLEX */
  if (asch>=0 && asch<r.n && bpch>=0 && bpch<r.n) {
    if (r.ch[bpch].sr==r.ch[asch].sr) {
      na=(unsigned long)(r.ts_1*r.ch[bpch].sr);
      if (na>=r.ch[bpch].n) na=r.ch[bpch].n-1;
      ne=(unsigned long)(r.ts_2*r.ch[bpch].sr);
      if (ne>=r.ch[bpch].n) ne=r.ch[bpch].n-1;
      upcount=0; downcount=0; updown=0; brrptr=0; seqptr=0; seqcount=0; nampli=0;
      n=na;
      find_dia(r.ch[bpch].data, n, ne, thres, &ndia, &nsys); nampli++;
      ndia_alt=ndia; nsys_alt=nsys;
      n=nsys;
      find_dia(r.ch[bpch].data, n, ne, thres, &ndia, &nsys); nampli++;
      bp_alt=0;
      for (m=ndia_alt; m<ndia; m++) bp_alt+=r.ch[bpch].data[m];
      bp_alt=bp_alt/(ndia-ndia_alt);
      as_alt=0;
      for (m=ndia_alt; m<ndia; m++) as_alt+=r.ch[asch].data[m];
      as_alt=as_alt/(ndia-ndia_alt);
      ndia_alt=ndia; nsys_alt=nsys;
      n=nsys;
      while (n<ne) {
	find_dia(r.ch[bpch].data, n, ne, thres, &ndia, &nsys); nampli++;
	if(ndia<ne){
	  bp=0;
	  for (m=ndia_alt; m<ndia; m++) bp+=r.ch[bpch].data[m];
	  bp=bp/(ndia-ndia_alt);
	  as=0;
	  for (m=ndia_alt; m<ndia; m++) as+=r.ch[asch].data[m];
	  as=as/(ndia-ndia_alt);
	  if (bp_alt<bp && as_alt>as) {
	    updown=1;
	    upcount++;
	    if(upcount==1) {
	      brr[1][brrptr]=bp_alt;
	      brr[2][brrptr]=as_alt;
	      brr[3][seqptr]=ndia_alt/r.ch[bpch].sr;
	    }
	    if(upcount==2) {
	      brr[1][brrptr+1]=bp_alt;
	      brr[2][brrptr+1]=as_alt;
	      brr[1][brrptr+2]=bp;
	      brr[2][brrptr+2]=as;
	    }
	    if(upcount==3) {
	      brr[0][seqptr]=upcount+1; seqptr++; seqcount++;
	      brr[1][brrptr+3]=bp;
	      brr[2][brrptr+3]=as;
	      brrptr+=4;
	    }
	    if(upcount>3) {
	      brr[0][seqptr-1]=upcount+1;
	      brr[1][brrptr]=bp;
	      brr[2][brrptr]=as;
	      brrptr++;
	    }
	    downcount=0;
	  }
	  else if (bp_alt>bp && as_alt<as) {
	    updown=-1;
	    downcount++;
	    if(downcount==1) {
	      brr[1][brrptr]=bp_alt;
	      brr[2][brrptr]=as_alt;
	      brr[3][seqptr]=ndia_alt/r.ch[bpch].sr;
	    }
	    if(downcount==2) {
	      brr[1][brrptr+1]=bp_alt;
	      brr[2][brrptr+1]=as_alt;
	      brr[1][brrptr+2]=bp;
	      brr[2][brrptr+2]=as;
	    }
	    if(downcount==3) {
	      brr[0][seqptr]=downcount+1; seqptr++; seqcount++;
	      brr[1][brrptr+3]=bp;
	      brr[2][brrptr+3]=as;
	      brrptr+=4;
	    }
	    if(downcount>3) {
	      brr[0][seqptr-1]=downcount+1;
	      brr[1][brrptr]=bp;
	      brr[2][brrptr]=as;
	      brrptr++;
	    }
	    upcount=0;
	  }
	  else {
	    updown=0;
	    downcount=0;
	    upcount=0;
	  }
	  bp_alt=bp; as_alt=as;
	}
	ndia_alt=ndia; nsys_alt=nsys;
	n=nsys;
      }

      /* draw vertical lines at rectangle */
      yunits=0;
      for (i=0; i<r.n; i++)
	if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
      yoff=0;
      for (i=0; i<=asch; i++) {
	if (r.view[i].is_visible) {
	  yd=(int)(((float)(ht*(r.ch[i].height+1)))/(float)yunits);
	  yoff+=yd;
	}
      }
      set_color(drawing_a, "blue", NULL, gc);
      XDrawLine(dpy, xwin, gc, x1, yoff, x1, yoff-yd);
      XDrawLine(dpy, xwin, gc, x2, yoff, x2, yoff-yd);
      set_color(drawing_a, "black", NULL, gc);
      m=0; seqs=0;
      for (n=0; n<seqcount; n++) {
	for(i=0; i<brr[0][n]; i++) {
	  brrx[i]=brr[1][m];
	  brry[i]=brr[2][m];
	  m++;
	}
	pearsn(brrx-1,brry-1,(unsigned long) brr[0][n], &cc, &prob, &z);
	if (fabs(cc)>=ccsoll/100) {
	  xpos=LMAR+(int)((brr[3][n]-r.t_1)*(float)(wd-LMAR)/(r.t_2-r.t_1));
	  set_color(drawing_a, "red", NULL, gc);
	  XDrawLine(dpy,xwin,gc,
		    xpos, yoff,
		    xpos, yoff-yd);
	  set_color(drawing_a, "black", NULL, gc);
	  seqs++;
	}
	else {
	  brr[0][n]=(-1)*brr[0][n];
	}
      }
      /* show report */
      barowin("Baroreflex Analysis: Associated Channel", nampli, seqcount, brr);
    } 
    else {
      showmess(drawing_a, "Baroreflex", "sampling rate of BP-channel\nand y-axis-channel must be equal");
    }
  }

  XtUnmanageChild(widget);
  delete brrx; delete brry;
}

